## eztrace 2.0+repack

=== CMakeLists.txt ===
cmake_minimum_required (VERSION 3.1)
project(EZTrace
  VERSION 2.0.0
  LANGUAGES C
)


# include CMake modules
include(CheckLibraryExists)
include(CheckIncludeFiles)
include(CheckFunctionExists)
include(GNUInstallDirs)
include(CheckLanguage)
include(CheckCSourceCompiles)
include(CTest)

# POLICIES #####################
if (POLICY CMP0074)
  cmake_policy(SET CMP0074 NEW)
  cmake_policy(SET CMP0079 NEW)
endif()

# RPATH ########################################
set(CMAKE_MACOSX_RPATH 1)
set(CMAKE_SKIP_BUILD_RPATH FALSE) # use, i.e. don't skip the full RPATH for the build tree
set(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE) # when building, don't use the install RPATH already (but later on when installing)
set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_FULL_LIBDIR}") # the RPATH to be used when installing

# CMakeFind repository
list (APPEND CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake_modules)

find_package (OTF2 REQUIRED)
if (NOT OTF2_FOUND)
   message(FATAL_ERROR "libotf2 not found.")
endif()

SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -I${OTF2_INCLUDE_PATH}")
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -I${OTF2_INCLUDE_PATH}")

SET(CMAKE_C_FLAGS  "${CMAKE_C_FLAGS} -D_GNU_SOURCE")
SET(CMAKE_CXX_FLAGS  "${CMAKE_CXX_FLAGS} -D_GNU_SOURCE")

# Check if fortran is available
check_language(Fortran)
if(CMAKE_Fortran_COMPILER)
  enable_language(Fortran)
else()
  message(STATUS "No Fortran support")
endif()

# Look for library

#find_package (OpenMP)

# Options to enable/disable modules

option(EZTRACE_ENABLE_MPI      "Enable MPI module"      OFF)
#option(EZTRACE_ENABLE_CUDA     "Enable CUDA module"     OFF)
#option(EZTRACE_ENABLE_STARPU   "Enable StarPU module"   OFF)
option(EZTRACE_ENABLE_OPENMP   "Enable OpenMP module"   OFF)
#option(EZTRACE_ENABLE_PAPI     "Enable PAPI module"     OFF)
option(EZTRACE_ENABLE_POSIXIO  "Enable POSIXIO module"  ON)
option(EZTRACE_ENABLE_PTHREAD  "Enable Pthread module"  ON)
option(EZTRACE_ENABLE_MEMORY   "Enable Memory module"   OFF)
option(EZTRACE_ENABLE_OMPT     "Enable OMPT module"     OFF)
option(EZTRACE_ENABLE_IOTRACER "Enable IOtracer module" OFF)

SET(MPI_MODULE_NAME "mpi" CACHE STRING "Name of the MPI module")


option(ENABLE_BIN_INSTRUMENTATION "Enable binary instrumentation" OFF)

if(EZTRACE_ENABLE_IOTRACER)
  find_path(IOTRACER_PATH "bcc_iotracer.py" REQUIRED)
endif()

if(ENABLE_BIN_INSTRUMENTATION)
  find_library(BFD NAMES bfd)
  if (NOT BFD)
    message(FATAL_ERROR "libbfd found. This library is required for binary instrumentation")
  endif()

  find_package (LibOpcodes)
  CHECK_LIBRARY_EXISTS(opcodes disassembler "" disassembler_exist)
  if (NOT disassembler_exist)
    message(FATAL_ERROR "libopcodes: disassembler not found. This library is required for binary instrumentation")
  endif()

  set(EZTRACE_BINARY_INSTRUMENTATION_FLAG -DENABLE_BINARY_INSTRUMENTATION)

endif()

set (HAVE_DEMANGLE 0)
check_library_exists(iberty cplus_demangle "" cplus_demangle_exist)
if (cplus_demangle_exist)
  find_path (DEMANGLE_INCLUDEDIR NAMES "demangle.h"
    HINTS /usr/include/libiberty/
    )
  if(DEMANGLE_INCLUDEDIR)
    set (HAVE_DEMANGLE 1)
  else()
    message(WARNING " demangle.h not found. C++ symbols will not be demangled")
  endif()
else()
  message(WARNING " libiberty not found. C++ symbols will not be demangled")
endif()

if (EZTRACE_ENABLE_MPI)
  find_program(MPICC mpicc REQUIRED)
  find_program(MPIF90 mpif90)
endif()

# if (EZTRACE_ENABLE_STARPU)
#   find_package(STARPU "1.2" REQUIRED COMPONENTS HWLOC MPI)
#   list(APPEND CMAKE_INSTALL_RPATH ${STARPU_LIBRARY_DIRS})
# endif()
# 
# if (EZTRACE_ENABLE_PAPI)
#   find_package (LibPapi REQUIRED)
# endif()
# 
# if (EZTRACE_ENABLE_CUDA)
#   find_package (CUDA REQUIRED)
# endif()

if (EZTRACE_ENABLE_OPENMP)
  find_package (OpenMP REQUIRED)
  find_program(OPARI2 opari2)
  find_program(OPARI2_CONFIG opari2-config)
  IF( NOT OPARI2)
    message(FATAL_ERROR " opari2 was not found. Please download it from https://www.vi-hps.org/projects/score-p#opari2 and install it")
  endIF(NOT OPARI2)
  IF (NOT OPARI2_CONFIG)
    message(FATAL_ERROR " opari2-config was not found. Please download it from https://www.vi-hps.org/projects/score-p#opari2 and install it")
  endIF (NOT OPARI2_CONFIG)
endif()

if (EZTRACE_ENABLE_OMPT)
  find_package (OpenMP REQUIRED)
  find_package (OMPT REQUIRED)
endif()

#set(THREADS_PREFER_PTHREAD_GLAF ON)
#find_package(Threads REQUIRED)

####################################################
# Some flags for compilation

set (prefix "${CMAKE_INSTALL_PREFIX}")
set (INSTALL_PKGCONFIG_DIR "${CMAKE_INSTALL_PREFIX}/share/pkgconfig")

check_include_files("sys/prctl.h" HAVE_PRCTL_H)
if (NOT HAVE_PRCTL_H)
  set(HAVE_PRCTL_H 0)
endif()

check_include_files("libbacktrace/backtrace.h" HAVE_LIBBACKTRACE)
if (NOT HAVE_LIBBACKTRACE)
  set(HAVE_LIBBACKTRACE 0)
endif()

set(LIBRARY_PATH "${CMAKE_INSTALL_PREFIX}/lib")
if ("${APPLE}")
  set(DYNLIB_EXT "dylib")
  set(LD_PRELOAD_NAME "DYLD_INSERT_LIBRARIES")
  set(LD_LIBRARY_PATH_NAME "DYLD_LIBRARY_PATH")
else() # By default -> Linux
  set(DYNLIB_EXT "so")
  set(LD_PRELOAD_NAME "LD_PRELOAD")
  set(LD_LIBRARY_PATH_NAME "LD_LIBRARY_PATH")
endif()

set(EZTRACE_LIB_DIR ${CMAKE_INSTALL_FULL_LIBDIR})
#set(PPTRACE_BINARY_TYPE "PPTRACE_BINARY_TYPE_BFD")
#set(__PPTRACE_BINARY_TYPE "PPTRACE_BINARY_TYPE_BFD")
#set(abs_top_builddir ${CMAKE_BINARY_DIR})

set(INSTALL_INCLUDEDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_INCLUDEDIR}")
set(INSTALL_LIBDIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")

# Subdirectory
add_subdirectory (src)
add_subdirectory (test/unit_tests)

include(PrintOpts)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/eztrace.pc.in
               ${CMAKE_CURRENT_BINARY_DIR}/eztrace.pc)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/eztrace.pc DESTINATION "${INSTALL_PKGCONFIG_DIR}")

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

#####################################################

add_subdirectory(core)
add_subdirectory(instrumentation)
add_subdirectory(eztrace-lib)
add_subdirectory(modules)
add_subdirectory(plugin_creator)

#####################################################
# eztrace.preload

configure_file (
  ${CMAKE_CURRENT_SOURCE_DIR}/eztrace.preload.in
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace.preload
  @ONLY # ask cmake to change only variables in the form @VAR@ (ie. don't touch the ${VAR} variables, which can be problematic for bash scripts)
  )

list(APPEND SCRIPTS
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace.preload
  )

#####################################################
# eztrace

configure_file (${CMAKE_CURRENT_SOURCE_DIR}/eztrace.c.in ${CMAKE_CURRENT_BINARY_DIR}/eztrace.c)

add_executable(eztrace
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace.c
)

target_compile_options(eztrace
  PRIVATE
    -Wall -Wextra -Wpedantic
    -Werror
    -DEZTRACE_ABS_TOP_BUILDDIR="" # TODO
    -Wno-gnu-zero-variadic-macro-arguments
)

target_include_directories(eztrace
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
  )

target_link_libraries(eztrace
  PRIVATE
    eztrace-instrumentation
    eztrace-lib
)

#####################################################
# eztrace_avail
add_executable(eztrace_avail
  eztrace_avail.c
  )

target_compile_options(eztrace_avail
  PRIVATE
  -Wall -Wextra -Wpedantic
  -Werror
  -Wno-gnu-zero-variadic-macro-arguments
  )

target_link_libraries(eztrace_avail
  PRIVATE
    eztrace-lib
)

set_target_properties(eztrace_avail 
  PROPERTIES C_STANDARD 99
)

################################################

set_target_properties(eztrace 
  PROPERTIES C_STANDARD 11
)

#####################################################

install(PROGRAMS ${SCRIPTS} DESTINATION ${CMAKE_INSTALL_BINDIR})

install(
  TARGETS eztrace eztrace_avail
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== src/core/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/eztrace_config.h.in ${CMAKE_CURRENT_BINARY_DIR}/include/eztrace-core/eztrace_config.h)

add_library(eztrace-core SHARED
  ezt_demangle.c
  eztrace_array.c
  eztrace_htable.c
  eztrace_sampling.c
  eztrace_config.c
  include/eztrace-core/ezt_demangle.h
  include/eztrace-core/eztrace_array.h
  include/eztrace-core/eztrace_htable.h
  include/eztrace-core/eztrace_list.h
  include/eztrace-core/eztrace_macros.h
  include/eztrace-core/eztrace_sampling.h
  include/eztrace-core/eztrace_spinlock.h
  include/eztrace-core/eztrace_stack.h
  include/eztrace-core/eztrace_types.h
  include/eztrace-core/eztrace_attributes.h
  include/eztrace-core/types.h
)

target_include_directories(eztrace-core
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-core
  PRIVATE
    -Wall -Wextra
    -Werror
)

if (HAVE_DEMANGLE)
  target_include_directories(eztrace-core
    PRIVATE
      ${DEMANGLE_INCLUDEDIR}
  )
  target_compile_options(eztrace-core
    PRIVATE
      -DHAVE_DEMANGLE
  )
  target_link_libraries(eztrace-core
    PRIVATE
      iberty
  )
endif()

install(TARGETS eztrace-core EXPORT EZTraceCoreTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT EZTraceCoreTargets
  FILE EZTraceCore.cmake
  NAMESPACE EZTrace::
  DESTINATION cmake
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-core DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
install(DIRECTORY ${CMAKE_CURRENT_BINARY_DIR}/include/eztrace-core DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/eztrace-lib/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

add_library(eztrace-lib SHARED
  eztrace_core.c
  eztrace_otf2.c
  eztrace_internals.c
  eztrace_module.c
  include/eztrace-lib/eztrace.h
  include/eztrace-lib/eztrace_otf2.h
  include/eztrace-lib/eztrace_internals.h
  include/eztrace-lib/eztrace_module.h
  pthread_core.c
)

target_include_directories(eztrace-lib
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-lib
  PUBLIC
    -D_GNU_SOURCE
  PRIVATE
    -Wall -Wextra  -Wno-gnu-zero-variadic-macro-arguments
)

target_link_libraries(eztrace-lib
  PUBLIC
    eztrace-core
    dl
    PRIVATE
    ${CMAKE_DL_LIBS}
    rt
    ${OTF2_LIBRARY}
    m
    )

install(TARGETS eztrace-lib EXPORT EZTraceLibTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT EZTraceLibTargets
  FILE EZTraceLib.cmake
  NAMESPACE EZTrace::
  DESTINATION cmake
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-lib DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/instrumentation/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set(EZTRACE_BINARY_INSTRUMENTATION_SOURCES
  binary.h
  errors.c
  include/eztrace-instrumentation/errors.h
  include/eztrace-instrumentation/linux.h
  include/eztrace-instrumentation/pptrace.h
  pptrace.c
  proc_maps.c
  proc_maps.h
  include/eztrace-instrumentation/tracing.h
  tracing.c
)

SET(COMPILE_FLAGS "")

if(ENABLE_BIN_INSTRUMENTATION)

  list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
    binary_instrumentation/bfd.c
    binary_instrumentation/binary.c
    binary_instrumentation/hijack.c
    binary_instrumentation/hijack.h
    binary_instrumentation/isize.h
    binary_instrumentation/memory.c
    binary_instrumentation/memory.h
    binary_instrumentation/opcodes.h
  )

if(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "x86_64")
  list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
    binary_instrumentation/arch/x86_64/hijack.c
    binary_instrumentation/arch/x86_64/intel.c)

  if(LIBOPCODES_FOUND)
    list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
      binary_instrumentation/arch/x86_64/opcode.c)
  else()
    list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
      binary_instrumentation/arch/x86_64/trace.c)
  endif()

  string(APPEND COMPILE_FLAGS -DHAVE_CHECK_INSTRUCTIONS)

endif()

if(CMAKE_HOST_SYSTEM_PROCESSOR MATCHES "arm")
  list(APPEND EZTRACE_BINARY_INSTRUMENTATION_SOURCES
    binary_instrumentation/arch/armv7/arm.c
    binary_instrumentation/arch/armv7/opcode.c
    binary_instrumentation/arch/armv7/trace.c)
endif()

  set(EZTRACE_BINARY_INSTRUMENTATION_DEPS
    PRIVATE
      bfd
      opcodes
  )
endif()

add_library(eztrace-instrumentation SHARED ${EZTRACE_BINARY_INSTRUMENTATION_SOURCES})

target_include_directories(eztrace-instrumentation
  PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDE_DIR}>
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}/binary_instrumentation
    ${CMAKE_CURRENT_SOURCE_DIR}
)

target_compile_options(eztrace-instrumentation
  PUBLIC
    ${EZTRACE_BINARY_INSTRUMENTATION_FLAG}
  PRIVATE
    # -Werror # TODO
    ${COMPILE_FLAGS}
)

target_link_libraries(eztrace-instrumentation
    ${EZTRACE_BINARY_INSTRUMENTATION_DEPS}
  PUBLIC
    eztrace-core
)

if (ENABLE_BIN_INSTRUMENTATION)
  target_link_libraries(eztrace-instrumentation
    PRIVATE
  )
endif()


install(TARGETS eztrace-instrumentation EXPORT EZTraceInstrumentationTargets
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
)

install(EXPORT EZTraceInstrumentationTargets
  FILE EZTraceInstrumentation.cmake
  NAMESPACE EZTrace::
  DESTINATION cmake
)

install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/include/eztrace-instrumentation DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

=== src/modules/CMakeLists.txt ===
# Default modules
if(EZTRACE_ENABLE_MEMORY)
  add_subdirectory(memory)
endif()
if(EZTRACE_ENABLE_POSIXIO)
  add_subdirectory(posixio)
endif()
if(EZTRACE_ENABLE_PTHREAD)
  add_subdirectory(pthread)
endif()

# Optional modules
if (EZTRACE_ENABLE_MPI)
  add_subdirectory(mpi)
endif ()

if (EZTRACE_ENABLE_OPENMP)
  add_subdirectory(omp)
endif()

# Some modules have not been ported to OTF2 yet

#if (EZTRACE_ENABLE_PAPI)
#  add_subdirectory(papi)
#endif ()
#
#if (EZTRACE_ENABLE_STARPU)
#  add_subdirectory(starpu)
#endif ()
#
#if (EZTRACE_ENABLE_CUDA)
#  add_subdirectory(cuda)
#endif ()

if (EZTRACE_ENABLE_OMPT)
  add_subdirectory(ompt)
endif()

if(EZTRACE_ENABLE_IOTRACER)
  add_subdirectory(iotracer)
endif()

=== src/plugin_creator/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

set (INSTALL_INPUTDIR ${CMAKE_INSTALL_FULL_DATADIR})
set (INSTALL_BINDIR ${CMAKE_INSTALL_FULL_BINDIR})

configure_file(${CMAKE_CURRENT_SOURCE_DIR}/eztrace_create_plugin.in 
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace_create_plugin
  @ONLY)


list(APPEND SCRIPTS
  ${CMAKE_CURRENT_BINARY_DIR}/eztrace_create_plugin
  ${CMAKE_CURRENT_SOURCE_DIR}/function.pm
  )


install(PROGRAMS ${SCRIPTS} DESTINATION ${CMAKE_INSTALL_BINDIR})
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/input DESTINATION ${CMAKE_INSTALL_DATADIR})

=== test/memory/Makefile ===
BIN=memory vector
SHELL := /bin/bash

top_src_dir=$(PWD)/../../
cur_dir=$(PWD)

all: $(BIN)

vector: vector.cxx
	$(CXX) -o vector vector.cxx

test: all
	./run.sh

clean:
	rm -f $(BIN)

=== test/mpi/Makefile ===
CC=mpicc
BIN=mpi_ring mpi_multiring mpi_spawn test_mpi waitall waitany persistent mpi_ping allgather

all: $(BIN)

test: all
	./run.sh

clean:
	rm -f $(BIN)

=== test/openmp/Makefile ===
CC=eztrace_cc cc
CXX=eztrace_cc g++
CFLAGS=-fopenmp
LDFLAGS=-fopenmp -lm

BIN=openmp_nowait_c openmp_simple openmp_cpp parallel test_lock test_nest_lock test_task

all: $(BIN)

%: %.c
	$(CC) -o $@ $^ $(CFLAGS) $(LDFLAGS)
%: %.cpp
	$(CXX) -o $@ $^ $(CFLAGS) $(LDFLAGS)

test: $(BIN)
	./run.sh
clean:
	rm -f $(BIN)

=== test/unit_tests/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

enable_testing()

add_executable(htable
  htable.c)

# depending on the framework, you need to link to it
target_link_libraries(htable
  eztrace-core)

target_compile_options(htable
  PRIVATE
    -Wall -Wextra -Wpedantic
    -Werror
)

target_include_directories(htable
  PRIVATE
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

add_test(NAME htable COMMAND htable)

add_test (mpi_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../mpi/run.sh)
add_test (memory_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../memory/run.sh)
add_test (openmp_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../openmp/run.sh)
add_test (ompt_tests bash ${CMAKE_CURRENT_SOURCE_DIR}/../ompt/run.sh)

=== src/modules/iotracer/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.1)

add_library(eztrace-iotracer SHARED
  iotracer.c
  iotracer_to_otf2.c
)

target_link_libraries(eztrace-iotracer
  PRIVATE
    dl
    eztrace-core
    eztrace-lib
    eztrace-instrumentation
)

target_include_directories(eztrace-iotracer
  PRIVATE
  ${CMAKE_SOURCE_DIR}/src/core/include/eztrace-core/
)

#---------------------------------------------

install(TARGETS eztrace-iotracer
  LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
  RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR}
  INCLUDES DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
)

=== debian/changelog ===
eztrace (2.0+repack-1) unstable; urgency=medium

  * src/modules/omp/pomp-lib-dummy: Restore eztrace's libpomp.
  * debian/copyright: Don't filter out pomp-lib-dummy.
  * patches/no-libpomp: Drop.
  * debian/libeztrace0.install: Add usr/lib/*/libeztpomp.so.
  * tests/control: Add build-essential, otf2-tools, clang, bc, gawk dependency.
  * tests/control: Make tests output verbose.
  * tests/control: Clean binaries between tests.
  * tests/control: Allow some stderr, skip non-installable ompt and openmpi.
  * tests/control: Enable openmp test.
  * libeztrace0.lintian-overrides: Complete overrides.
  * control: Fix libeztrace0 short description.
  * patches/git-test-mpi-path: Make mpi path configurable.
  * tests/control: Configure mpi paths.
  * patches/git-mpi-init: Fix mpi module name hardcoding.
  * tests/control: Enable mpi tests.
  * patches/git-libatomic: Fix 8-byte atomic use on some archs.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 23 Aug 2022 17:02:45 +0200

eztrace (2.0-3) unstable; urgency=medium

  * patches/git-opari2: Fix build against opari2.
  * patches/git-arm: Fix build on some arm archs.
  * patches/git-mpi-types: Fix build with some mpi implementations.
  * patches/git-atomic: Try to fix atomic operations on mips.
  * patches/git-test-openmp: Fix openmp test.
  * rules: Enable openmp module.
  * patches/test_utils: replace with upstream's git-test-path.
  * tests/control: Add autopkgtest.

 -- Samuel Thibault <sthibault@debian.org>  Tue, 23 Aug 2022 13:52:13 +0200

eztrace (2.0-2) unstable; urgency=medium

  * patches/werror: Disable -Werror.
  * debian/control, rules: Enable ompt only on archs which have libomp-dev.
  * debian/control: eztrace: Add missing perl:Depends dependencies.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 22 Aug 2022 16:07:10 +0200

eztrace (2.0-1) unstable; urgency=medium

  * New upstream release
    - control: Build-dep on cmake.
    - patches/binutils-2.38.50: Merged.
    - patches/extlib: Drop, now useless.
    - patches/no-rpath: Drop, now useless.
    - patches/ptrace-arm: Drop, now useless.
    - patches/no-libpomp: Update.
    - patches/reproducibility: Update.
    - patches/static-bfd: Update.
    - patches/rename: Fix discovering Debian's otf2.
    - rules: Update to cmake.
    - control: Replace fxt-tools, libgtg-dev, liblitl-dev (>= 0.1.9~),
      litl-tools build-deps with libotf2-trace-dev, otf2-tools.
    - control: Add opari2 build-dep.
    - control: Add clang, libomp-dev build-deps.
    - rules: Add ompt build with clang.
    - patches/otf2-3: Fix build against otf2 3.0.
    - docs, eztrace.install, libeztrace-dev.install, libeztrace0.install:
      Update installed files.
    - patches/test_utils: Workaround path to test_utils.sh
    - patches/norpath: Disable rpath.
    - control: Drop libeztrace-dev dependency on liblitl-dev.
    - patches/pkg-config: Drop spurious compilation flags.
    - patches/mpi_module_name: Fix loading right mpi module during tests.
    - patches/test-ompt: Fix enabling only tests for which a module was built.
    - patches/git-input: Fix path for template files.
    - patches/git-no-install-cmake: Avoid installing cmake files.
    - libeztrace0.lintian-overrides: Ignore missing version in modules.
    - patches/git-pkgconfig: Fix pkg-config file installation path.
    - patches/git-manpage: Install manpages.
    - patches/git-functions: Fix installation of functions.pm
  * watch: Update regexp.
  * gbp.conf, copyright: Replace gbp filter with copyright Files-Excluded.

 -- Samuel Thibault <sthibault@debian.org>  Mon, 22 Aug 2022 14:25:30 +0200

eztrace (1.1-11-3) unstable; urgency=medium

  * control: Bump Standards-Version to 4.6.0 (no change)
  * patches/binutils-2.38.50: Fix build against binutils 2.38.50.
    (Closes: Bug#1013517)

 -- Samuel Thibault <sthibault@debian.org>  Fri, 24 Jun 2022 14:08:20 +0200

=== debian/control ===
Source: eztrace
Section: devel
Priority: optional
Maintainer: Samuel Thibault <sthibault@debian.org>
Build-Depends: debhelper-compat (= 12),
 pkg-config,
 cmake,
 gfortran,
 libiberty-dev, binutils-dev (>= 2.29~), zlib1g-dev,
 libotf2-trace-dev, otf2-tools,
 opari2, libpomp2-dev,
 clang, libomp-dev [amd64 arm64 i386 ppc64el riscv64],
 libstarpu-dev (>= 1.3~),
 libpapi-dev [amd64 arm64 armel armhf i386 mipsel powerpc ppc64el mips64el ppc64 x32],
 libmpich-dev, mpi-default-dev, mpi-default-bin
Rules-Requires-Root: no
Build-Conflicts: libeztrace0
Standards-Version: 4.6.0
Homepage: https://eztrace.gitlab.io/eztrace/
Vcs-Git: https://salsa.debian.org/debian/eztrace.git
Vcs-Browser: https://salsa.debian.org/debian/eztrace

Package: eztrace
Architecture: any
Depends: ${shlibs:Depends}, ${perl:Depends}, ${misc:Depends}, libeztrace0 (= ${binary:Version}), opari2
Description: Automatic execution trace generation for HPC - tools
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the tools.

Package: libeztrace-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libeztrace0 (= ${binary:Version}), ${misc:Depends}
Description: Automatic execution trace generation for HPC - development files
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

Package: libeztrace0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Pre-Depends: ${misc:Pre-Depends}
Description: Automatic execution trace generation for HPC - runtime libraries
 EZTrace is a tool that aims at generating automatically execution traces
 from HPC (High Performance Computing) programs. It generates execution
 trace files that can be interpreted by visualization tools such as
 ViTE. It uses LD_PRELOAD and dlsym() to intercept calls to the usual HPC
 primitives, to be observed.
 .
 This package contains the development files.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

include /usr/share/dpkg/architecture.mk
include /usr/share/mpi-default-dev/debian_defaults

ifeq ($(ARCH_DEFAULT_MPI_IMPL),openmpi)
OPENMPI=yes
else
OPENMPI=no
endif

OMPT_ARCHS = amd64 arm64 i386 ppc64el riscv64

CONFIGURE_ENV=
CONFIGURE=-DEZTRACE_ENABLE_MPI=ON \
	  -DEZTRACE_ENABLE_MEMORY=ON \
	  -DEZTRACE_ENABLE_OPENMP=ON \
	  -DCMAKE_INSTALL_INCLUDEDIR=/usr/include/$(DEB_HOST_MULTIARCH)

%:
	dh $@

override_dh_auto_configure:
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-mpich -- $(CONFIGURE) -DMPICC=/usr/bin/mpicc.mpich -DMPIF90=/usr/bin/mpif90.mpich -DMPI_MODULE_NAME=mpich
ifeq ($(OPENMPI),yes)
	$(CONFIGURE_ENV) dh_auto_configure -Bbuild-openmpi -- $(CONFIGURE) -DMPICC=/usr/bin/mpicc.openmpi -DMPIF90=/usr/bin/mpif90.openmpi -DMPI_MODULE_NAME=openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	$(CONFIGURE_ENV) CC=clang dh_auto_configure -Bbuild-ompt -- -DEZTRACE_ENABLE_OMPT=ON
endif

override_dh_auto_build:
	dh_auto_build -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_build -Bbuild-openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_build -Bbuild-ompt
endif

override_dh_auto_clean:
	dh_auto_clean -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_clean -Bbuild-openmpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_clean -Bbuild-ompt
endif

override_dh_auto_install:
	dh_auto_install -Bbuild-mpich
ifeq ($(OPENMPI),yes)
	dh_auto_install -Bbuild-openmpi -- -C src/modules/mpi
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	dh_auto_install -Bbuild-ompt -- -C src/modules/ompt
endif

export EZTRACE_LIBRARY_PATH=../../src/modules/mpi:../../src/modules/memory:../../src/modules/ompt:../../src/modules/omp
override_dh_auto_test:
	MPI_MODULE_NAME=mpich EZTRACE_ABS_TOP_BUILDDIR=$(CURDIR)/build-mpich/ dh_auto_test --no-parallel -Bbuild-mpich -- -k
ifeq ($(OPENMPI),yes)
	MPI_MODULE_NAME=openmpi EZTRACE_ABS_TOP_BUILDDIR=$(CURDIR)/build-openmpi/ dh_auto_test --no-parallel -Bbuild-openmpi -- -k
endif
ifneq ($(filter $(DEB_HOST_ARCH),$(OMPT_ARCHS)),)
	EZTRACE_ABS_TOP_BUILDDIR=$(CURDIR)/build-ompt/ dh_auto_test --no-parallel -Bbuild-ompt -- -k
endif

override_dh_dwz:
	:

=== debian/tests/control ===
Depends: build-essential, eztrace, otf2-tools, clang, libomp-dev, gawk
Test-Command: cd test/ompt ; make clean ; verbose=1 ./run.sh
Restrictions: skip-not-installable

Depends: build-essential, eztrace, otf2-tools, libpomp2-dev, bc, gawk
Test-Command: cd test/openmp ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, mpich, libmpich-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPICC_PATH=mpicc.mpich MPIRUN_PATH=mpirun.mpich MPI_MODULE_NAME=mpich verbose=1 ./run.sh
Restrictions: allow-stderr

Depends: build-essential, eztrace, otf2-tools, openmpi-bin, libopenmpi-dev, gawk
Test-Command: cd test/mpi ; make clean ; MPICC_PATH=mpicc.openmpi MPIRUN_PATH=mpirun.openmpi MPI_MODULE_NAME=openmpi verbose=1 ./run.sh
Restrictions: skip-not-installable

Depends: build-essential, eztrace, otf2-tools
Test-Command: cd test/pthread ; make clean ; verbose=1 ./run.sh

Depends: build-essential, eztrace, otf2-tools, gawk
Test-Command: cd test/memory ; make clean ; verbose=1 ./run.sh

Depends: build-essential, eztrace, otf2-tools, bc
Test-Command: cd test/posixio ; make clean ; verbose=1 ./run.sh
Restrictions: allow-stderr
